local classes = { }

-- a
classes[          "adventurer"]	= { classTypes = {        "fighter" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[           "alchemist"]	= { classTypes = {        "crafter" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[       "animalhandler"]	= { classTypes = {         "nature" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(        "child") }
classes[  "antiquities dealer"]	= { classTypes = {         "trader" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(        "adult") }
classes[              "archer"]	= { classTypes = {        "fighter" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween("young adult",  "mature adult") }
classes[        "archeologist"]	= { classTypes = {        "scholar" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[        "\"archmage\""] = { classTypes = {          "other" }, races = { "blood elf",
                        														       	   									     "gnome",
                                                                                  "half elf",
                                                                                  "high elf",
                                                                                     "human",
                                                                                 "night elf" },	faiths = {                      "any" },	ages = agesBetween(      "child",         "child") }
classes[             "armorer"] = { classTypes = {        "crafter" }, races = {       "any" }, faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[            "assassin"] = { classTypes = {          "rogue" }, races = allRacesExcept(
                                                                                   "draenei" ), faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[          "astrologer"] = { classTypes = {        "scholar" }, races = { "blood elf",
                                                                                     "gnome",
                                                                                  "half elf",
                                                                                  "high elf",
                                                                                     "human",
                                                                                 "night elf" },	faiths = {                      "any" },  ages = olderThan(  "young adult") }
classes[          "astronomer"] = { classTypes = {        "scholar" }, races = { "blood elf",
                                                                                     "gnome",
                                                                                  "half elf",
                                                                                  "high elf",
                                                                                     "human",
                                                                                 "night elf" },	faiths = {                      "any" },  ages = olderThan(  "young adult") }
classes[              "author"]	= { classTypes = {        "scholar" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
-- b
classes[               "baker"]	= { classTypes = {        "kitchen" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[                "bard"]	= { classTypes = {    "entertainer" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[           "bartender"]	= { classTypes = {        "kitchen" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween("young adult",  "mature adult") }
classes[              "beggar"]	= { classTypes = {         "rogue", }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(        "child") }
classes[          "blacksmith"]	= { classTypes = {        "crafter" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween("young adult",         "adult") }
classes[                "brat"] = { classTypes = {          "other" }, races = {       "any" },	faiths = {                      "any" },  ages = agesBetween(      "child",         "child") }
classes[             "brawler"] = { classTypes = {        "fighter" }, races = allRacesExcept(
                                                                                  "pandaren" ),	faiths = {                      "any" },  ages = olderThan(         "teen") }
classes[          "blood mage"]	= { classTypes = {          "magic" }, races = { "blood elf" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[           "bodyguard"] = { classTypes = {        "fighter" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[          "bookbinder"] = { classTypes = {        "crafter",
                                                          "scholar" }, races = { "blood elf",
                                                                                     "dwarf",
                                                                                     "gnome",
                                                                                  "half elf",
                                                                                  "half orc",
                                                                                  "high elf",
                                                                                     "human",
                                                                                    "undead",
                                                                                    "worgen" }, faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[       "bounty hunter"] = { classTypes = {        "fighter" }, races = {       "any" }, faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[              "bowyer"]	= { classTypes = {        "crafter" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween("young adult",  "mature adult") }
classes[              "brewer"]	= { classTypes = {        "kitchen" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[       "brothelkeeper"] = { classTypes = {          "other" }, races = { "blood elf",
                                                                                   "draenei",
                                                                                     "dwarf",
                                                                                     "gnome",
                                                                                    "goblin",
                                                                                  "half elf",
                                                                                  "half orc",
                                                                                  "high elf",
                                                                                     "human",
                                                                                 "night elf",
                                                                                       "orc",
                                                                                  "pandaren",
                                                                                     "troll",
                                                                                    "undead",
                                                                                    "worgen" }, faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[       "brothelworker"] = { classTypes = {          "other" }, races = { "blood elf",
                                                                                   "draenei",
                                                                                     "dwarf",
                                                                                     "gnome",
                                                                                    "goblin",
                                                                                  "half elf",
                                                                                  "half orc",
                                                                                  "high elf",
                                                                                     "human",
                                                                                 "night elf",
                                                                                       "orc",
                                                                                  "pandaren",
                                                                                     "troll",
                                                                                    "worgen" }, faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[             "burglar"]	= { classTypes = {          "rogue" }, races = {       "any" }, faiths = {                      "any" },	ages = agesBetween(       "teen",         "adult") }
classes[             "butcher"] = { classTypes = {        "kitchen" }, races = {       "any" }, faiths = {                      "any" },	ages = olderThan(         "teen") }
-- c
classes[         "candlemaker"] = { classTypes = {        "crafter" }, races = {     "dwarf",
                                                                                     "gnome",
                                                                                  "half elf",
                                                                                  "half orc",
                                                                                  "high elf",
                                                                                     "human",
                                                                                  "pandaren",
                                                                                    "undead",
                                                                                    "worgen" },	faiths = {                      "any" },	ages = olderThan(        "child") }
classes[           "carpenter"] = { classTypes = {        "crafter" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes["carpenter apprentice"] = { classTypes = {     "apprentice" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween(      "child",          "teen") }
classes[              "clergy"] = { classTypes = {          "light" }, races = {       "any" },	faiths = faithsByTag(         "light" ),	ages = olderThan(         "teen") }
classes[            "clothier"] = { classTypes = {        "crafter" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(        "child") }
classes[             "cobbler"] = { classTypes = {        "crafter" }, races = allRacesExcept(
                                                                                   "draenei",
                                                                                  "pandaren",
                                                                                    "tauren" ),	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[  "cobbler apprentice"] = { classTypes = {     "apprentice" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween(      "child",          "teen") }
classes[            "commoner"]	= { classTypes = {          "other" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(        "child") }
classes[                "cook"]	= { classTypes = {        "kitchen" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween("young adult",  "mature adult") }
classes[           "craftsman"] = { classTypes = {        "crafter" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[             "cultist"]	= { classTypes = {           "dark" }, races = {       "any" },	faiths = faithsByTag(          "cult" ),	ages = olderThan(        "child") }
-- d
classes[         "dark ranger"] = { classTypes = {        "fighter" }, races = {    "undead" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[        "demon hunter"]	= { classTypes = {        "fighter" }, races = { "blood elf", 
                                                                                 "night elf" },	faiths = {             "the illidari" },	ages = olderThan(  "young adult") }
classes[            "diplomat"] = { classTypes = {        "scholar" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[              "doctor"]	= { classTypes = {        "medical" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(        "adult") }
classes[           "doomsayer"]	= { classTypes = {           "dark" }, races = {       "any" },	faiths = faithsByTag(          "cult" ),	ages = olderThan(        "child") }
classes[               "druid"]	= { classTypes = {         "nature" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween("young adult",     "venerable") }
classes[             "drummer"] = { classTypes = {    "entertainer" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(        "child") }
classes[               "drunk"] = { classTypes = {          "other" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
-- e
classes[           "enchanter"]	= { classTypes = {          "magic" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[            "engineer"]	= { classTypes = {        "crafter" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[        "entrepreneur"] = { classTypes = {          "other" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[            "explorer"] = { classTypes = {          "other" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
-- f
classes[          "farstrider"] = { classTypes = {        "fighter" }, races = { "blood elf" },	faiths = {                      "any" },	ages = agesBetween(      "adult",  "mature adult") }
classes[              "farmer"]	= { classTypes = {       "gatherer" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween("young adult",         "elder") }
classes[           "fisherman"]	= { classTypes = {       "gatherer" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween("young adult",         "adult") }
classes[          "fishmonger"] = { classTypes = {         "trader" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[        "fruit vendor"] = { classTypes = {         "trader" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(        "child") }
-- g
classes[            "gardener"] = { classTypes = {          "other" }, races = { "blood elf",
                                                                                     "gnome",
                                                                                  "half elf",
                                                                                  "half orc",
                                                                                  "high elf",
                                                                                     "human",
                                                                                 "night elf",
                                                                                  "pandaren",
                                                                                    "worgen" },	faiths = {                      "any" },	ages = olderThan(        "child") }
classes[               "guard"]	= { classTypes = {        "fighter" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[               "grunt"]	= { classTypes = {        "fighter" }, races = {       "orc" },	faiths = {                      "any" },	ages = agesBetween("young adult",         "adult") }
-- h
classes[         "hairdresser"] = { classTypes = {          "other" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[        "hay merchant"] = { classTypes = {         "trader" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[          "headhunter"] = { classTypes = {        "fighter" }, races = {     "troll" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[              "herald"] = { classTypes = {          "other" }, races = { "blood elf",
                                                                                   "draenei",
                                                                                     "dwarf",
                                                                                     "gnome",
                                                                                    "goblin",
                                                                                  "half elf",
                                                                                  "half orc",
                                                                                  "high elf",
                                                                                     "human",
                                                                                       "orc",
                                                                                  "pandaren",
                                                                                    "worgen" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[           "herbalist"]	= { classTypes = {       "gatherer" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[     "homeless person"]	= { classTypes = {          "rogue" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween(      "child",         "child") }
classes[       "horse trainer"] = { classTypes = {         "animal" }, races = { "blood elf",
                                                                                     "dwarf",
                                                                                  "half elf",
                                                                                  "half orc",
                                                                                  "high elf",
                                                                                     "human",
                                                                                    "undead",
                                                                                    "worgen" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[              "hunter"]	= { classTypes = {         "nature" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween("young adult",  "mature adult") }
-- i
classes[         "illuminator"] = { classTypes = {          "magic",
                                                            "other" }, races = { "blood elf",
                                                                                     "dwarf",
                                                                                    "goblin",
                                                                                     "gnome",
                                                                                  "half elf",
                                                                                  "half orc",
                                                                                  "high elf",
                                                                                     "human",
                                                                                 "night elf",
                                                                                       "orc",
                                                                                  "pandaren",
                                                                                    "tauren",
                                                                                    "worgen",
                                                                                    "undead" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[           "innkeeper"]	= { classTypes = {          "other" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(        "adult") }
classes[            "inventor"] = { classTypes = {        "crafter" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
-- j
classes[              "jailer"] = { classTypes = {          "other" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[              "jester"] = { classTypes = {    "entertainer" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(        "child") }
classes[        "jewelcrafter"]	= { classTypes = {        "crafter" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[             "juggler"] = { classTypes = {    "entertainer" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween(      "child",         "elder") }
-- k
classes[        "kitchen help"] = { classTypes = {        "kitchen" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(        "child") }
classes[              "knight"] = { classTypes = {        "fighter" }, races = {     "human" },	faiths = {                      "any" },	ages = olderThan(        "adult") }
-- l
classes[             "laborer"] = { classTypes = {        "crafter" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween(       "teen",  "mature adult") }
classes[       "leatherworker"]	= { classTypes = {        "crafter" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[       "loan provider"] = { classTypes = {          "other" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[             "lookout"] = { classTypes = {          "rogue" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween(      "child",   "young adult") }
classes[          "lorewalker"]	= { classTypes = {        "scholar" }, races = {  "pandaren" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[          "lumberjack"] = { classTypes = {       "gatherer" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween(       "teen",  "mature adult") }
-- m
classes[                "mage"]	= { classTypes = {          "magic" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween("young adult",     "venerable") }
classes[        "mathmatician"] = { classTypes = {        "scholar" }, races = { "blood elf",
                                                                                     "dwarf",
                                                                                     "gnome",
                                                                                    "goblin",
                                                                                  "half elf",
                                                                                  "high elf",
                                                                                     "human",
                                                                                    "undead",
                                                                                    "worgen" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[               "medic"]	= { classTypes = {        "medical" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween("young adult",         "elder") }
classes[           "mercenary"]	= { classTypes = {        "fighter" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween(       "teen",  "mature adult") }
classes[            "merchant"]	= { classTypes = {         "trader" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween(       "teen",         "elder") }
classes[           "messenger"] = { classTypes = {          "other" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(        "child") }
classes[    "military advisor"] = { classTypes = {        "scholar" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(        "adult") }
classes[                "mime"] = { classTypes = {    "entertainer" }, races = { "blood elf",
                                                                                     "dwarf",
                                                                                     "gnome",
                                                                                  "half elf",
                                                                                  "half orc",
                                                                                  "high elf",
                                                                                     "human",
                                                                                    "worgen" },	faiths = {                      "any" },	ages = olderThan(        "child") }
classes[               "miner"]	= { classTypes = {       "gatherer" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween(       "teen",  "mature adult") }
classes[                "monk"]	= { classTypes = {        "fighter" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[            "musician"] = { classTypes = {    "entertainer" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
-- n
classes[               "nanny"] = { classTypes = {      "childcare" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[           "navigator"] = { classTypes = {          "other" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[         "necromancer"] = { classTypes = {           "dark" }, races = {       "any" },	faiths = {       "cult of the damned" },	ages = olderThan(        "adult") }
classes[               "nurse"]	= { classTypes = {      "childcare" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
-- o
classes[  "old clothes dealer"] = { classTypes = {         "trader" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[              "outlaw"] = { classTypes = {          "rogue" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(        "child") }
-- p
classes[                "page"] = { classTypes = {     "apprentice" }, races = { "blood elf",
                                                                                     "dwarf",
                                                                                   "draenei",
                                                                                    "goblin",
                                                                                  "half elf",
                                                                                  "high elf",
                                                                                     "human",
                                                                                 "night elf",
                                                                                    "tauren" },	faiths = {                      "any" },	ages = agesBetween(      "child",         "child") }
classes[             "painter"]	= { classTypes = {        "crafter" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[             "paladin"] = { classTypes = {        "fighter" }, races = { "blood elf",
                                                                                   "draenei",
                                                                                     "dwarf",
                                                                                  "half elf",
                                                                                  "half orc",
                                                                                  "high elf",
                                                                                     "human",
                                                                                    "tauren" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[             "peasant"] = { classTypes = {          "other" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(        "child") }
classes[          "pharmacist"] = { classTypes = {         "trader" }, races = { "blood elf",
                                                                                     "dwarf",
                                                                                     "gnome",
                                                                                  "half elf",
                                                                                  "half orc",
                                                                                  "high elf",
                                                                                     "human",
                                                                                    "worgen" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[         "philosopher"] = { classTypes = {        "scholar" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(        "adult") }
classes[           "physician"] = { classTypes = {        "medical" }, races = { "blood elf",
                                                                                     "dwarf",
                                                                                     "gnome",
                                                                                    "goblin",
                                                                                  "half elf",
                                                                                  "half orc",
                                                                                  "high elf",
                                                                                     "human",
                                                                                    "worgen" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[          "pickpocket"]	= { classTypes = {          "rogue" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween(      "child",          "teen") }
classes[          "pie seller"] = { classTypes = {         "trader" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[               "piper"] = { classTypes = {        "crafter" }, races = { "blood elf",
                                                                                     "dwarf",
                                                                                     "gnome",
                                                                                  "half elf",
                                                                                  "half orc",
                                                                                  "high elf",
                                                                                     "human",
                                                                                 "night elf",
                                                                                  "pandaren",
                                                                                    "tauren",
                                                                                     "troll",
                                                                                    "worgen" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[    "piper apprentice"] = { classTypes = {     "apprentice" }, races = { "blood elf",
                                                                                     "dwarf",
                                                                                     "gnome",
                                                                                  "half elf",
                                                                                  "half orc",
                                                                                  "high elf",
                                                                                     "human",
                                                                                 "night elf",
                                                                                  "pandaren",
                                                                                    "tauren",
                                                                                     "troll",
                                                                                    "worgen" },	faiths = {                      "any" },	ages = agesBetween(      "child",          "teen") }
classes[              "pirate"] = { classTypes = {        "fighter" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[              "potter"] = { classTypes = {        "crafter" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[   "potter apprentice"] = { classTypes = {     "apprentice" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween(      "child",          "teen") }
classes[            "preacher"] = { classTypes = {          "light" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[              "priest"]	= { classTypes = {          "light" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween("young adult",     "venerable") }
-- q
-- r
classes[              "ranger"] = { classTypes = {        "fighter" }, races = { "blood elf",
                                                                                     "human",
                                                                                  "high elf",
																				                          			            "undead" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[              "rascal"] = { classTypes = {          "other" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween(      "child",         "child") }
classes[               "rebel"] = { classTypes = {          "other" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(        "child") }
-- s
classes[              "sailor"] = { classTypes = {          "other" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[    			   "scholar"]	= { classTypes = {        "scholar" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[               "scout"]	= { classTypes = {        "fighter" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween("young adult",  "mature adult") }
classes[              "scribe"]	= { classTypes = {        "scholar" }, races = racesByType(
                                                                                 "civilized" ),	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[            "scullion"] = { classTypes = {        "crafter" }, races = { "blood elf",
                                                                                     "dwarf",
                                                                                     "gnome",
                                                                                  "half elf",
                                                                                  "half orc",
                                                                                  "high elf",
                                                                                     "human",
                                                                                 "night elf",
                                                                                  "pandaren",
                                                                                    "undead",
                                                                                    "worgen" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[             "servant"] = { classTypes = {          "other" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(        "child") }
classes[               "sewer"] = { classTypes = {          "other" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(        "child") }
classes[       "shadow hunter"] = { classTypes = {           "dark" }, races = {     "troll" },	faiths = {                      "any" },	ages = olderThan(        "adult") }
classes[              "shaman"]	= { classTypes = {         "nature" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween("young adult",     "venerable") }
classes[            "shepherd"] = { classTypes = {          "other" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(        "child") }
classes[          "shopkeeper"]	= { classTypes = {         "trader" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween("young adult",  "mature adult") }
classes[             "skinner"] = { classTypes = {       "gatherer" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[  "skinner apprentice"] = { classTypes = {     "apprentice" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween(      "child",          "teen") }
classes[             "soldier"]	= { classTypes = {        "fighter" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween(       "teen",  "mature adult") }
classes[            "sorcerer"]	= { classTypes = {          "magic" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[        "spellbreaker"] = { classTypes = {          "magic" }, races = { "blood elf" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[                 "spy"] = { classTypes = {          "rogue" }, races = allRacesExcept(
                                                                                   "draenei",
                                                                                    "tauren" ),	faiths = {                      "any" },	ages = olderThan(        "child") }
classes[              "squire"] = { classTypes = {     "apprentice", 
                                                          "fighter" }, races = { "blood elf",
                                                                                   "draenei",
                                                                                    "goblin",
                                                                                  "half elf",
                                                                                  "high elf",
                                                                                     "human",
                                                                                 "night elf",
                                                                                    "tauren" },	faiths = {                      "any" },	ages = agesBetween(      "child",   "young adult") }
classes[          "stablehand"] = { classTypes = {          "other" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween(      "child",   "young adult") }
classes[             "student"]	= { classTypes = {          "child" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween(      "child",          "teen") }
classes[             "surgeon"] = { classTypes = {        "medical" }, races = racesByType(
                                                                                 "civilized" ),	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[            "swindler"] = { classTypes = {          "rogue" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(        "child") }
-- t
classes[              "tailor"]	= { classTypes = {        "crafter" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[             "teacher"]	= { classTypes = {      "childcare" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[               "thief"]	= { classTypes = {          "rogue" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween(      "child",  "mature adult") }
classes[              "tinker"] = { classTypes = {        "crafter" }, races = {     "gnome",
                                                                                    "goblin" },	faiths = {                      "any" },	ages = olderThan(  "young adult") }
classes[             "trapper"] = { classTypes = {       "gatherer" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
-- u 
-- v
classes[              "vendor"]	= { classTypes = {         "trader" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
-- w
classes[              "waiter"]	= { classTypes = {          "other" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween(      "child",  "mature adult") }
classes[             "warlock"]	= { classTypes = {           "dark" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween("young adult",     "venerable") }
classes[            "watchman"] = { classTypes = {        "fighter" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[        "water vendor"] = { classTypes = {         "trader" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[         "wine vendor"] = { classTypes = {         "trader" }, races = { "blood elf",
                                                                                   "draenei",
                                                                                     "dwarf",
                                                                                     "gnome",
                                                                                    "goblin",
                                                                                  "half elf",
                                                                                  "half orc",
                                                                                  "high elf",
                                                                                     "human",
                                                                                 "night elf",
                                                                                  "pandaren",
                                                                                    "undead" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[        "witch doctor"]	= { classTypes = {         "nature" }, races = {     "troll" },	faiths = {                      "any" },	ages = olderThan(        "adult") }
classes[          "woodcarver"] = { classTypes = {        "crafter" }, races = {       "any" },	faiths = {                      "any" },	ages = olderThan(        "child") }

classes[          "woodworker"]	= { classTypes = {        "crafter" }, races = {       "any" },	faiths = {                      "any" },	ages = agesBetween("young adult",  "mature adult") }
classes[          "woolseller"] = { classTypes = {         "trader" }, races = {     "dwarf",
                                                                                     "gnome",
                                                                                  "half elf",
                                                                                  "half elf",
                                                                                  "high elf",
                                                                                     "human",
                                                                                    "undead",
                                                                                    "worgen" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
classes[        "wool-stapler"] = { classTypes = {        "crafter" }, races = {     "dwarf",
                                                                                     "gnome",
                                                                                  "half elf",
                                                                                  "half orc",
                                                                                  "high elf",
                                                                                     "human",
                                                                                    "undead",
                                                                                    "worgen" },	faiths = {                      "any" },	ages = olderThan(         "teen") }
-- x
-- y
-- z

-- allClassesExcept :: Class -> ... -> { Class }
function allClassesExcept(...)
  local exceptions = {...}
  return without(keys(classes),exceptions)
end

-- classesByType :: ClassType -> { Class }
function classesByType(classType)
  return filterKeysByValue(
    function(x) return
      contains(classType, x.classTypes)
    end,
    eitherOr(classType == "any", { }, classes)
  )
end

-- generateRandomClass :: (Race a, Age a) => a -> Class
function generateRandomClass(characterTemplate)
  return randomFrom(
    filterKeysByValue(
      function(val) return
        (
          contains(characterTemplate:getRace(),   val.races) or 
          contains("any", val.races)
        ) and (
          contains(characterTemplate:getAge(),     val.ages) or
          contains("any", val.ages)
        ) and (
          contains(characterTemplate:getFaith(), val.faiths) or
          contains("any", val.faiths)
        )
      end,
      classes
    )
  ) or "Error: No options found!"
end

function randomClass()
  return randomFrom(keys(classes))
end

-- End of File.